# coding=utf-8
# pylint: disable=too-many-lines
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator (autorest: 3.9.7, generator: @autorest/python@6.9.4)
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

import datetime
import sys
from typing import Any, Dict, List, Optional, TYPE_CHECKING, Union

from .. import _serialization

if sys.version_info >= (3, 9):
    from collections.abc import MutableMapping
else:
    from typing import MutableMapping  # type: ignore  # pylint: disable=ungrouped-imports

if TYPE_CHECKING:
    # pylint: disable=unused-import,ungrouped-imports
    from .. import models as _models
JSON = MutableMapping[str, Any]  # pylint: disable=unsubscriptable-object


class Conversation(_serialization.Model):
    """Conversation.

    :ivar messages:
    :vartype messages: list[~context_api.models.Message]
    :ivar metadata: Dictionary of :code:`<string>`.
    :vartype metadata: dict[str, str]
    """

    _attribute_map = {
        "messages": {"key": "messages", "type": "[Message]"},
        "metadata": {"key": "metadata", "type": "{str}"},
    }

    def __init__(
        self,
        *,
        messages: Optional[List["_models.Message"]] = None,
        metadata: Optional[Dict[str, str]] = None,
        **kwargs: Any
    ) -> None:
        """
        :keyword messages:
        :paramtype messages: list[~context_api.models.Message]
        :keyword metadata: Dictionary of :code:`<string>`.
        :paramtype metadata: dict[str, str]
        """
        super().__init__(**kwargs)
        self.messages = messages
        self.metadata = metadata


class ConversationResponse(_serialization.Model):
    """ConversationResponse.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar metadata: Dictionary of :code:`<string>`. Required.
    :vartype metadata: dict[str, str]
    :ivar sentiment_trend: Required. Known values are: "up", "flat", and "down".
    :vartype sentiment_trend: str or ~context_api.models.ConversationSentimentTrend
    :ivar topics: Required.
    :vartype topics: list[~context_api.models.Topic]
    :ivar suggested_topics: Required.
    :vartype suggested_topics: list[~context_api.models.Topic]
    :ivar messages: Required.
    :vartype messages: list[~context_api.models.MessageResponse]
    """

    _validation = {
        "id": {"required": True},
        "metadata": {"required": True},
        "sentiment_trend": {"required": True},
        "topics": {"required": True},
        "suggested_topics": {"required": True},
        "messages": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "metadata": {"key": "metadata", "type": "{str}"},
        "sentiment_trend": {"key": "sentiment_trend", "type": "str"},
        "topics": {"key": "topics", "type": "[Topic]"},
        "suggested_topics": {"key": "suggested_topics", "type": "[Topic]"},
        "messages": {"key": "messages", "type": "[MessageResponse]"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        metadata: Dict[str, str],
        sentiment_trend: Union[str, "_models.ConversationSentimentTrend"],
        topics: List["_models.Topic"],
        suggested_topics: List["_models.Topic"],
        messages: List["_models.MessageResponse"],
        **kwargs: Any
    ) -> None:
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword metadata: Dictionary of :code:`<string>`. Required.
        :paramtype metadata: dict[str, str]
        :keyword sentiment_trend: Required. Known values are: "up", "flat", and "down".
        :paramtype sentiment_trend: str or ~context_api.models.ConversationSentimentTrend
        :keyword topics: Required.
        :paramtype topics: list[~context_api.models.Topic]
        :keyword suggested_topics: Required.
        :paramtype suggested_topics: list[~context_api.models.Topic]
        :keyword messages: Required.
        :paramtype messages: list[~context_api.models.MessageResponse]
        """
        super().__init__(**kwargs)
        self.id = id
        self.metadata = metadata
        self.sentiment_trend = sentiment_trend
        self.topics = topics
        self.suggested_topics = suggested_topics
        self.messages = messages


class Message(_serialization.Model):
    """Message.

    :ivar role: Known values are: "system", "assistant", and "user".
    :vartype role: str or ~context_api.models.MessageParamsRole
    :ivar message:
    :vartype message: str
    :ivar type: Known values are: "message" and "tool".
    :vartype type: str or ~context_api.models.MessageParamsType
    :ivar event_timestamp:
    :vartype event_timestamp: ~datetime.datetime
    :ivar metadata: Dictionary of :code:`<string>`.
    :vartype metadata: dict[str, str]
    :ivar rating: Known values are: -1, 0, and 1.
    :vartype rating: int or ~context_api.models.Rating
    :ivar name:
    :vartype name: str
    :ivar thought:
    :vartype thought: str
    :ivar input: Any object.
    :vartype input: JSON
    :ivar observation:
    :vartype observation: str
    """

    _attribute_map = {
        "role": {"key": "role", "type": "str"},
        "message": {"key": "message", "type": "str"},
        "type": {"key": "type", "type": "str"},
        "event_timestamp": {"key": "event_timestamp", "type": "iso-8601"},
        "metadata": {"key": "metadata", "type": "{str}"},
        "rating": {"key": "rating", "type": "int"},
        "name": {"key": "name", "type": "str"},
        "thought": {"key": "thought", "type": "str"},
        "input": {"key": "input", "type": "object"},
        "observation": {"key": "observation", "type": "str"},
    }

    def __init__(
        self,
        *,
        role: Optional[Union[str, "_models.MessageParamsRole"]] = None,
        message: Optional[str] = None,
        type: Union[str, "_models.MessageParamsType"] = "message",
        event_timestamp: Optional[datetime.datetime] = None,
        metadata: Optional[Dict[str, str]] = None,
        rating: Optional[Union[int, "_models.Rating"]] = None,
        name: Optional[str] = None,
        thought: Optional[str] = None,
        input: Optional[JSON] = None,
        observation: Optional[str] = None,
        **kwargs: Any
    ) -> None:
        """
        :keyword role: Known values are: "system", "assistant", and "user".
        :paramtype role: str or ~context_api.models.MessageParamsRole
        :keyword message:
        :paramtype message: str
        :keyword type: Known values are: "message" and "tool".
        :paramtype type: str or ~context_api.models.MessageParamsType
        :keyword event_timestamp:
        :paramtype event_timestamp: ~datetime.datetime
        :keyword metadata: Dictionary of :code:`<string>`.
        :paramtype metadata: dict[str, str]
        :keyword rating: Known values are: -1, 0, and 1.
        :paramtype rating: int or ~context_api.models.Rating
        :keyword name:
        :paramtype name: str
        :keyword thought:
        :paramtype thought: str
        :keyword input: Any object.
        :paramtype input: JSON
        :keyword observation:
        :paramtype observation: str
        """
        super().__init__(**kwargs)
        self.role = role
        self.message = message
        self.type = type
        self.event_timestamp = event_timestamp
        self.metadata = metadata
        self.rating = rating
        self.name = name
        self.thought = thought
        self.input = input
        self.observation = observation


class MessageResponse(_serialization.Model):  # pylint: disable=too-many-instance-attributes
    """MessageResponse.

    All required parameters must be populated in order to send to Azure.

    :ivar type: Known values are: "message" and "tool".
    :vartype type: str or ~context_api.models.MessageType
    :ivar event_timestamp:
    :vartype event_timestamp: ~datetime.datetime
    :ivar role: Required. Known values are: "system", "assistant", and "user".
    :vartype role: str or ~context_api.models.MessageRole
    :ivar message: Required.
    :vartype message: str
    :ivar rating: Required. Known values are: -1, 0, and 1.
    :vartype rating: int or ~context_api.models.MessageRating
    :ivar language: Required.
    :vartype language: str
    :ivar translation:
    :vartype translation: str
    :ivar sentiment: Required.
    :vartype sentiment: float
    :ivar topics: Required.
    :vartype topics: list[~context_api.models.Topic]
    :ivar suggested_topics:
    :vartype suggested_topics: list[~context_api.models.Topic]
    :ivar metadata: Dictionary of :code:`<string>`.
    :vartype metadata: dict[str, str]
    """

    _validation = {
        "role": {"required": True},
        "message": {"required": True},
        "rating": {"required": True},
        "language": {"required": True},
        "sentiment": {"required": True},
        "topics": {"required": True},
    }

    _attribute_map = {
        "type": {"key": "type", "type": "str"},
        "event_timestamp": {"key": "event_timestamp", "type": "iso-8601"},
        "role": {"key": "role", "type": "str"},
        "message": {"key": "message", "type": "str"},
        "rating": {"key": "rating", "type": "int"},
        "language": {"key": "language", "type": "str"},
        "translation": {"key": "translation", "type": "str"},
        "sentiment": {"key": "sentiment", "type": "float"},
        "topics": {"key": "topics", "type": "[Topic]"},
        "suggested_topics": {"key": "suggested_topics", "type": "[Topic]"},
        "metadata": {"key": "metadata", "type": "{str}"},
    }

    def __init__(
        self,
        *,
        role: Union[str, "_models.MessageRole"],
        message: str,
        rating: Union[int, "_models.MessageRating"],
        language: str,
        sentiment: float,
        topics: List["_models.Topic"],
        type: Union[str, "_models.MessageType"] = "message",
        event_timestamp: Optional[datetime.datetime] = None,
        translation: Optional[str] = None,
        suggested_topics: Optional[List["_models.Topic"]] = None,
        metadata: Optional[Dict[str, str]] = None,
        **kwargs: Any
    ) -> None:
        """
        :keyword type: Known values are: "message" and "tool".
        :paramtype type: str or ~context_api.models.MessageType
        :keyword event_timestamp:
        :paramtype event_timestamp: ~datetime.datetime
        :keyword role: Required. Known values are: "system", "assistant", and "user".
        :paramtype role: str or ~context_api.models.MessageRole
        :keyword message: Required.
        :paramtype message: str
        :keyword rating: Required. Known values are: -1, 0, and 1.
        :paramtype rating: int or ~context_api.models.MessageRating
        :keyword language: Required.
        :paramtype language: str
        :keyword translation:
        :paramtype translation: str
        :keyword sentiment: Required.
        :paramtype sentiment: float
        :keyword topics: Required.
        :paramtype topics: list[~context_api.models.Topic]
        :keyword suggested_topics:
        :paramtype suggested_topics: list[~context_api.models.Topic]
        :keyword metadata: Dictionary of :code:`<string>`.
        :paramtype metadata: dict[str, str]
        """
        super().__init__(**kwargs)
        self.type = type
        self.event_timestamp = event_timestamp
        self.role = role
        self.message = message
        self.rating = rating
        self.language = language
        self.translation = translation
        self.sentiment = sentiment
        self.topics = topics
        self.suggested_topics = suggested_topics
        self.metadata = metadata


class Paths11Gsqt2ApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchema(_serialization.Model):
    """Paths11Gsqt2ApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchema.

    All required parameters must be populated in order to send to Azure.

    :ivar topic: Required.
    :vartype topic: ~context_api.models.Topic
    :ivar statistics: Required.
    :vartype statistics:
     ~context_api.models.Paths1MjxjdtApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchemaPropertiesStatistics  # pylint: disable=line-too-long
    """

    _validation = {
        "topic": {"required": True},
        "statistics": {"required": True},
    }

    _attribute_map = {
        "topic": {"key": "topic", "type": "Topic"},
        "statistics": {
            "key": "statistics",
            "type": "Paths1MjxjdtApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchemaPropertiesStatistics",
        },
    }

    def __init__(
        self,
        *,
        topic: "_models.Topic",
        statistics: "_models.Paths1MjxjdtApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchemaPropertiesStatistics",
        **kwargs: Any
    ) -> None:
        """
        :keyword topic: Required.
        :paramtype topic: ~context_api.models.Topic
        :keyword statistics: Required.
        :paramtype statistics:
         ~context_api.models.Paths1MjxjdtApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchemaPropertiesStatistics  # pylint: disable=line-too-long
        """
        super().__init__(**kwargs)
        self.topic = topic
        self.statistics = statistics


class Paths1MjxjdtApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchemaPropertiesStatistics(
    _serialization.Model
):
    """Paths1MjxjdtApiV1TopicSuggestionsIdStatisticsGetResponses200ContentApplicationJsonSchemaPropertiesStatistics.

    All required parameters must be populated in order to send to Azure.

    :ivar conversation_count: Required.
    :vartype conversation_count: int
    :ivar user_message_count: Required.
    :vartype user_message_count: int
    :ivar assistant_message_count: Required.
    :vartype assistant_message_count: int
    :ivar mean_sentiment: Required.
    :vartype mean_sentiment: float
    :ivar mean_user_rating: Required.
    :vartype mean_user_rating: float
    """

    _validation = {
        "conversation_count": {"required": True},
        "user_message_count": {"required": True},
        "assistant_message_count": {"required": True},
        "mean_sentiment": {"required": True, "maximum": 1, "minimum": -1},
        "mean_user_rating": {"required": True, "maximum": 1, "minimum": -1},
    }

    _attribute_map = {
        "conversation_count": {"key": "conversation_count", "type": "int"},
        "user_message_count": {"key": "user_message_count", "type": "int"},
        "assistant_message_count": {"key": "assistant_message_count", "type": "int"},
        "mean_sentiment": {"key": "mean_sentiment", "type": "float"},
        "mean_user_rating": {"key": "mean_user_rating", "type": "float"},
    }

    def __init__(
        self,
        *,
        conversation_count: int,
        user_message_count: int,
        assistant_message_count: int,
        mean_sentiment: float,
        mean_user_rating: float,
        **kwargs: Any
    ) -> None:
        """
        :keyword conversation_count: Required.
        :paramtype conversation_count: int
        :keyword user_message_count: Required.
        :paramtype user_message_count: int
        :keyword assistant_message_count: Required.
        :paramtype assistant_message_count: int
        :keyword mean_sentiment: Required.
        :paramtype mean_sentiment: float
        :keyword mean_user_rating: Required.
        :paramtype mean_user_rating: float
        """
        super().__init__(**kwargs)
        self.conversation_count = conversation_count
        self.user_message_count = user_message_count
        self.assistant_message_count = assistant_message_count
        self.mean_sentiment = mean_sentiment
        self.mean_user_rating = mean_user_rating


class Paths1TzwckqApiV1TopicSuggestionsIdConversationsGetResponses200ContentApplicationJsonSchema(_serialization.Model):
    """Paths1TzwckqApiV1TopicSuggestionsIdConversationsGetResponses200ContentApplicationJsonSchema.

    All required parameters must be populated in order to send to Azure.

    :ivar count: Required.
    :vartype count: int
    :ivar conversations: Required.
    :vartype conversations: list[~context_api.models.ConversationResponse]
    """

    _validation = {
        "count": {"required": True},
        "conversations": {"required": True},
    }

    _attribute_map = {
        "count": {"key": "count", "type": "int"},
        "conversations": {"key": "conversations", "type": "[ConversationResponse]"},
    }

    def __init__(self, *, count: int, conversations: List["_models.ConversationResponse"], **kwargs: Any) -> None:
        """
        :keyword count: Required.
        :paramtype count: int
        :keyword conversations: Required.
        :paramtype conversations: list[~context_api.models.ConversationResponse]
        """
        super().__init__(**kwargs)
        self.count = count
        self.conversations = conversations


class Paths1U893W0ApiV1TopicSuggestionsGetResponses200ContentApplicationJsonSchema(_serialization.Model):
    """Paths1U893W0ApiV1TopicSuggestionsGetResponses200ContentApplicationJsonSchema.

    All required parameters must be populated in order to send to Azure.

    :ivar count: Required.
    :vartype count: int
    :ivar topics: Required.
    :vartype topics: list[~context_api.models.TopicWithSamples]
    """

    _validation = {
        "count": {"required": True},
        "topics": {"required": True},
    }

    _attribute_map = {
        "count": {"key": "count", "type": "int"},
        "topics": {"key": "topics", "type": "[TopicWithSamples]"},
    }

    def __init__(self, *, count: int, topics: List["_models.TopicWithSamples"], **kwargs: Any) -> None:
        """
        :keyword count: Required.
        :paramtype count: int
        :keyword topics: Required.
        :paramtype topics: list[~context_api.models.TopicWithSamples]
        """
        super().__init__(**kwargs)
        self.count = count
        self.topics = topics


class PathsLi5TynApiV1LogConversationPostRequestbodyContentApplicationJsonSchema(_serialization.Model):
    """PathsLi5TynApiV1LogConversationPostRequestbodyContentApplicationJsonSchema.

    :ivar conversation:
    :vartype conversation: ~context_api.models.Conversation
    """

    _attribute_map = {
        "conversation": {"key": "conversation", "type": "Conversation"},
    }

    def __init__(self, *, conversation: Optional["_models.Conversation"] = None, **kwargs: Any) -> None:
        """
        :keyword conversation:
        :paramtype conversation: ~context_api.models.Conversation
        """
        super().__init__(**kwargs)
        self.conversation = conversation


class PathsRai0VpApiV1LogConversationUpsertPostRequestbodyContentApplicationJsonSchema(_serialization.Model):
    """PathsRai0VpApiV1LogConversationUpsertPostRequestbodyContentApplicationJsonSchema.

    :ivar conversation:
    :vartype conversation: ~context_api.models.Conversation
    """

    _attribute_map = {
        "conversation": {"key": "conversation", "type": "Conversation"},
    }

    def __init__(self, *, conversation: Optional["_models.Conversation"] = None, **kwargs: Any) -> None:
        """
        :keyword conversation:
        :paramtype conversation: ~context_api.models.Conversation
        """
        super().__init__(**kwargs)
        self.conversation = conversation


class PathsY5Azv9ApiV1ConversationsGetResponses200ContentApplicationJsonSchema(_serialization.Model):
    """PathsY5Azv9ApiV1ConversationsGetResponses200ContentApplicationJsonSchema.

    All required parameters must be populated in order to send to Azure.

    :ivar count: Required.
    :vartype count: int
    :ivar conversations: Required.
    :vartype conversations: list[~context_api.models.ConversationResponse]
    """

    _validation = {
        "count": {"required": True},
        "conversations": {"required": True},
    }

    _attribute_map = {
        "count": {"key": "count", "type": "int"},
        "conversations": {"key": "conversations", "type": "[ConversationResponse]"},
    }

    def __init__(self, *, count: int, conversations: List["_models.ConversationResponse"], **kwargs: Any) -> None:
        """
        :keyword count: Required.
        :paramtype count: int
        :keyword conversations: Required.
        :paramtype conversations: list[~context_api.models.ConversationResponse]
        """
        super().__init__(**kwargs)
        self.count = count
        self.conversations = conversations


class Topic(_serialization.Model):
    """Topic.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    """

    _validation = {
        "id": {"required": True},
        "name": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
    }

    def __init__(self, *, id: str, name: str, **kwargs: Any) -> None:  # pylint: disable=redefined-builtin
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name


class TopicWithSamples(_serialization.Model):
    """TopicWithSamples.

    All required parameters must be populated in order to send to Azure.

    :ivar id: Required.
    :vartype id: str
    :ivar name: Required.
    :vartype name: str
    :ivar conversations_sample: Required.
    :vartype conversations_sample: list[~context_api.models.ConversationResponse]
    """

    _validation = {
        "id": {"required": True},
        "name": {"required": True},
        "conversations_sample": {"required": True},
    }

    _attribute_map = {
        "id": {"key": "id", "type": "str"},
        "name": {"key": "name", "type": "str"},
        "conversations_sample": {"key": "conversations_sample", "type": "[ConversationResponse]"},
    }

    def __init__(
        self,
        *,
        id: str,  # pylint: disable=redefined-builtin
        name: str,
        conversations_sample: List["_models.ConversationResponse"],
        **kwargs: Any
    ) -> None:
        """
        :keyword id: Required.
        :paramtype id: str
        :keyword name: Required.
        :paramtype name: str
        :keyword conversations_sample: Required.
        :paramtype conversations_sample: list[~context_api.models.ConversationResponse]
        """
        super().__init__(**kwargs)
        self.id = id
        self.name = name
        self.conversations_sample = conversations_sample
